function [LL,objvs,ctime,WDE,UWDE]=graph_edgeseg(Y,E,Ho,Hb,vec_img,method,model)

if size(Y,2)>size(Y,1)
    Y = Y';
end

N = size(Y,1);
E = E.^1;
WDimg = zeros(N,N);
for i=1:size(vec_img,2)
    WDimg = WDimg + (vec_img(:,i)*ones(N,1)'-ones(N,1)*vec_img(:,i)').^2;
end
WDE = (1./(1+(WDimg).^(2/2))).*E;

WDE = WDE*1 + 0.00001*E;
%% Cholesky factorization based LP
DI = diag(sum(WDE,1));
DJ = diag(sum(WDE,2));

WWDE = (DI+DJ+eye(N,N)*10^-5)-2*WDE;
%tic;
[UWDE_l2] = sparse(chol(WWDE));


%%
UWDE = UWDE_l2;
L = Ho;
A_eq = [UWDE            -eye(N,N)];
b_eq = [zeros(N,1)];

LL = [];
objvs = [];
xx = [];
ctime = 0;
x = [Ho;zeros(N,1)];
if strcmp(model,'MRF')
    for i=1:1
        global c AW_neq bw_neq;
        AW_neq = [ UWDE         -eye(N,N);
                  -UWDE         -eye(N,N);];
        bw_neq = [ zeros(N,1);
                   zeros(N,1);];
        

        options = optimset('Display','final','MaxFunEvals',9e9,'TolFun',1e-6,'Algorithm','interior-point',...
                           'GradObj','on','GradConstr','on','LargeScale','on',...
                           'Hessian','user-supplied','HessFcn',@hessinterior,'UseParallel','always');
        stime = cputime;

        if ~isempty(strfind(method,'CLP'))
            h=msgbox('Computing Our LP');
            f = [1000*(Hb-Ho); 1*ones(N,1)];
            c = f;

%% Default matlab function
%             [x,objv] = linprog(f,[AW_neq],[bw_neq],[],[],zeros(N+N,1),[ones(N,1);ones(N,1)],[],options);
%% My IPM code for testing gpu performance
%             [~,x,objvs] = mylp_ipm(f,[AW_neq],[bw_neq],zeros(N+N,1),[ones(N,1);ones(N,1)]);
%% Default matlab parralelization
            [x] = fmincon(@myobj,x,[],[],[],[],zeros(N+N,1),[ones(N,1);ones(N,1)],@myconstr,options);
%% MIT lp_solve (fastest)
%             lp = lp_maker(-f, [AW_neq], [bw_neq], [-ones(N*2,1)], zeros(N*2,1),ones(N*2,1), [], 1, 0);
%             solvestat = mxlpsolve('solve', lp);
%             objv = mxlpsolve('get_objective', lp);
%             x = mxlpsolve('get_variables', lp);
%%
            close(h);
            h=msgbox('Done');
            close(h);
        end     
                
        ctime = ctime + cputime - stime;
        L=L*0+x(1:N,1);

    end

    LL = [LL L];

    
end
%pack
clearvars -except LL objvs ctime WDE UWDE;

function [f gradf] = myobj(x)
global c
f = c'*x;
gradf = c;

function [c ceq gradc gradceq] = myconstr(x)
global AW_neq
ceq = [];
gradceq = [];

c = AW_neq*x;
gradc = AW_neq';

function h = hessinterior(x,lambda)
global AW_neq;
h = zeros(size(AW_neq,2),size(AW_neq,2));

